//+------------------------------------------------------------------+
//|                       Lypunov_Correlation_dimension_jytv1mq4.mq4 |
//|                           Copyright  2011, jaguar1637@yahoo.com |
//|                                                             nope |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, jaguar1637@yahoo.com"
#property link      "nope"

#property indicator_chart_window

extern int NPT  = 500; // "nombre observations"
extern int DIMEN = 3 ; // "Dimension";
extern int TAU = 2; // "LAG TIME for phase SPACE" // 2?
extern int DT = 0; // 
extern double SCALMX = 100;  // 100 ? MAximum divergence
extern double SCALMN  = 1; //  1? Minimum distance
extern double EVOLV  = 10 ; // 10 minutes Evolution TIme
extern int    LAG = 5; // Minimum TIME Between PAIRS"  5MN
int IND = 1; 
double SUM = 0;
double ITS= 0;
double THETA, THETA2;
double D, L, R, CR;
// VARS

double X[2000];   // DIM X(2000)
double PT1[12];  // PT1[12];
double PT2[12];  // PT2[12];
double Z[1000][10];   //  DIM Z(1000,10) //  dimension

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars;
   if (counted_bars >= Bars) 
      counted_bars = Bars;
      
   int i, j , k;
   
   if (Bars <=  1) 
         {
         ArrayResize(X,NPT);
         ArrayResize(PT1,12);   
         ArrayResize(PT2,12);          
         
         return (0);  
         }
//----   
   for(i=1; i<=NPT; i++)
      {
       X[i]= Close[i];
      }
 // DATA READ
   for  (i=1;i <= NPT ; i++)
   {
      for (j = 1; j<= DIMEN ; j++) 
      {
   	  // REconstruc Phase SPACE   Z[i,j] = X(i + (j+1) * TAU interpreted as it
		   Z[i][j] = X[i] + (j-1) * TAU; 
 	   }
   }
   
   NPT = NPT - (DIMEN*TAU);  // MAXIMUM LENGTH OF PHASE SPACE


   for ( k=1; k <= NPT ; k++) 
   {	
      for ( i = 1; i<=  NPT; i++)
		{
		    D=0;
		    for (j = 1; j<= DIMEN; j++) 
		    { 
			  D= D + MathPow((Z[LAG][j] - Z[i][j]),2);
		    }
		
		    D= MathSqrt(D);  // Calculation of DISTANCE
		
		if ( D > R)   // Distance Greater than R ? 
		{
			THETA2 = 0;
		}
		else
			THETA2 = 1;
			
		THETA = THETA + THETA2;  // COUNTING POINT
		
	  } // FIn boucle i
	
	LAG = LAG +1;

	// Cal Correlation Integrale
	CR=  1 / ((MathPow(NPT,2))* THETA);

	Comment("Lyapunov_Correlation_Dimension "+ CR);
	L = L+1;
	if (L > 12 ) 
			break;
    else
		{
		R = R + DT;
		CR=0;
		THETA= 0;
		THETA2= 0;
		LAG = 0;
		}
   }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+